com.google.cloud.dataflow.sdk.runners.inprocess

## Class StepTransformResult

- java.lang.Object
- - com.google.cloud.dataflow.sdk.runners.inprocess.StepTransformResult

    public abstract class StepTransformResult
    extends Object

An immutable `InProcessTransformResult`.

### Nested Class Summary

Nested Classes
`static class` `StepTransformResult.Builder` A builder for creating instances of `StepTransformResult`.

### Constructor Summary

Constructors
Constructor and Description
`StepTransformResult()`

### Method Summary

All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
`abstract com.google.cloud.dataflow.sdk.util.common.CounterSet` `getCounters()` Returns the `CounterSet` used by this `PTransform`, or null if this transform did not use a `CounterSet`.
`abstract Iterable<? extends InProcessPipelineRunner.UncommittedBundle<?>>` `getOutputBundles()` Returns the `(uncommitted) Bundles` output by this transform.
`abstract Set<com.google.cloud.dataflow.sdk.runners.inprocess.CommittedResult.OutputType>` `getOutputTypes()` Returns the types of output produced by this `PTransform`.
`abstract com.google.cloud.dataflow.sdk.util.state.CopyOnAccessInMemoryStateInternals<?>` `getState()` Returns the State used by the transform.
`abstract InMemoryWatermarkManager.TimerUpdate` `getTimerUpdate()` Returns a TimerUpdateBuilder that was produced as a result of this evaluation.
`abstract AppliedPTransform<?,?,?>` `getTransform()` Returns the `AppliedPTransform` that produced this result.
`abstract Iterable<? extends com.google.cloud.dataflow.sdk.util.WindowedValue<?>>` `getUnprocessedElements()` Returns elements that were provided to the `TransformEvaluator` as input but were not processed.
`abstract Instant` `getWatermarkHold()` Returns the Watermark Hold for the transform at the time this result was produced.
`static StepTransformResult.Builder` `withHold(AppliedPTransform<?,?,?> transform, Instant watermarkHold)`
`static StepTransformResult.Builder` `withoutHold(AppliedPTransform<?,?,?> transform)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### StepTransformResult

    public StepTransformResult()

### Method Detail

#### getTransform

    public abstract AppliedPTransform<?,?,?> getTransform()

Returns the `AppliedPTransform` that produced this result.

#### getOutputBundles

    public abstract Iterable<? extends InProcessPipelineRunner.UncommittedBundle<?>> getOutputBundles()

Returns the `(uncommitted) Bundles` output by this transform. These will be committed by the evaluation context as part of completing this result.

#### getUnprocessedElements

    public abstract Iterable<? extends com.google.cloud.dataflow.sdk.util.WindowedValue<?>> getUnprocessedElements()

Returns elements that were provided to the `TransformEvaluator` as input but were not processed.

#### getCounters

    @Nullable
    public abstract com.google.cloud.dataflow.sdk.util.common.CounterSet getCounters()

Returns the `CounterSet` used by this `PTransform`, or null if this transform did not use a `CounterSet`.

#### getWatermarkHold

    public abstract Instant getWatermarkHold()

Returns the Watermark Hold for the transform at the time this result was produced. If the transform does not set any watermark hold, returns `BoundedWindow.TIMESTAMP_MAX_VALUE`.

#### getState

    @Nullable
    public abstract com.google.cloud.dataflow.sdk.util.state.CopyOnAccessInMemoryStateInternals<?> getState()

Returns the State used by the transform. If this evaluation did not access state, this may return null.

#### getTimerUpdate

    public abstract InMemoryWatermarkManager.TimerUpdate getTimerUpdate()

Returns a TimerUpdateBuilder that was produced as a result of this evaluation. If the evaluation was triggered due to the delivery of one or more timers, those timers must be added to the builder before it is complete.

If this evaluation did not add or remove any timers, returns an empty TimerUpdate.

#### getOutputTypes

    public abstract Set<com.google.cloud.dataflow.sdk.runners.inprocess.CommittedResult.OutputType> getOutputTypes()

Returns the types of output produced by this `PTransform`. This may not include `CommittedResult.OutputType.BUNDLE`, as empty bundles may be dropped when the transform is committed.

#### withHold

    public static StepTransformResult.Builder withHold(AppliedPTransform<?,?,?> transform,
                                                       Instant watermarkHold)

#### withoutHold

    public static StepTransformResult.Builder withoutHold(AppliedPTransform<?,?,?> transform)